﻿/// Copyright (c) Taoffi Nassar, 2010. All Rights Reserved.
/// http://www.isosoft.org/taoffi
///
/// This code is provided as is for sample demonstration purpose
/// 

using System.ServiceModel;
using System.ServiceModel.Activation;

//namespace SilverDbDataGrid.Web
//{
	[ServiceContract(Namespace = "")]
	[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
	public class DataService
	{
		[OperationContract]
		public SilverDataTable GetData(string str_connet_string, string str_sql_command, int n_records)
		{
			SilverDataTable sl_table = new SilverDataTable();

			sl_table.UserDefinedSqlCommand = str_sql_command;

			if (n_records > 0)
				sl_table.MaxPageRecords = n_records;
			sl_table.GetData(str_connet_string);

			return sl_table;
		}
	}
//}
