﻿using System.Collections.Generic;


	public class Xml_invalid_rangeList : List<Xml_invalid_range>
	{
		private static Xml_invalid_rangeList	m_instance	= null;

		public static Xml_invalid_rangeList Instance
		{
			get
			{
				if( m_instance == null)
					m_instance = new Xml_invalid_rangeList();
				return m_instance;
			}
		}

		private static int[][]	m_ranges	=
		{
			new int[]	{	0x0,		0x08		},
			new int[]	{	0x0b,		0x0b		},
			new int[]	{	0x7F,		0x84		},
			new int[]	{	0x86,		0x9F		},
			new int[]	{	0xFDD0,		0xFDDF		},
			new int[]	{	0x1FFFE,	0x1FFFF		},
			new int[]	{	0x2FFFE,	0x2FFFF		},
			new int[]	{	0x3FFFE,	0x3FFFF		},
			new int[]	{	0x4FFFE,	0x4FFFF		},
			new int[]	{	0x5FFFE,	0x5FFFF		},
			new int[]	{	0x6FFFE,	0x6FFFF		},
			new int[]	{	0x7FFFE,	0x7FFFF		},
			new int[]	{	0x8FFFE,	0x8FFFF		},
			new int[]	{	0x9FFFE,	0x9FFFF		},
			new int[]	{	0xAFFFE,	0xAFFFF		},
			new int[]	{	0xBFFFE,	0xBFFFF		},
			new int[]	{	0xCFFFE,	0xCFFFF		},
			new int[]	{	0xDFFFE,	0xDFFFF		},
			new int[]	{	0xEFFFE,	0xEFFFF		},
			new int[]	{	0xFFFFE,	0xFFFFF		},
			new int[]	{	0x10FFFE,	0x10FFFF	}
		};


		private void init_instance()
		{
			Clear();

			for (int ndx0 = 0; ndx0 < m_ranges.Length; ndx0++)
			{
				Add( new Xml_invalid_range( m_ranges[ndx0][0], m_ranges[ndx0][1]));
			}
			//Add(	new Xml_invalid_range(0x0,		0x08	));
			//Add(	new Xml_invalid_range(0x0b,		0x0b	));
			//Add(	new Xml_invalid_range(0x7F,		0x84	));
			//Add(	new Xml_invalid_range(0x86,		0x9F	));
			//Add(	new Xml_invalid_range(0xFDD0,	0xFDDF	));
			//Add(	new Xml_invalid_range(0x1FFFE,	0x1FFFF	));
			//Add(	new Xml_invalid_range(0x2FFFE,	0x2FFFF	));
			//Add(	new Xml_invalid_range(0x3FFFE,	0x3FFFF	));
			//Add(	new Xml_invalid_range(0x4FFFE,	0x4FFFF	));
			//Add(	new Xml_invalid_range(0x5FFFE,	0x5FFFF	));
			//Add(	new Xml_invalid_range(0x6FFFE,	0x6FFFF	));
			//Add(	new Xml_invalid_range(0x7FFFE,	0x7FFFF	));
			//Add(	new Xml_invalid_range(0x8FFFE,	0x8FFFF	));
			//Add(	new Xml_invalid_range(0x9FFFE,	0x9FFFF	));
			//Add(	new Xml_invalid_range(0xAFFFE,	0xAFFFF	));
			//Add(	new Xml_invalid_range(0xBFFFE,	0xBFFFF	));
			//Add(	new Xml_invalid_range(0xCFFFE,	0xCFFFF	));
			//Add(	new Xml_invalid_range(0xDFFFE,	0xDFFFF	));
			//Add(	new Xml_invalid_range(0xEFFFE,	0xEFFFF	));
			//Add(	new Xml_invalid_range(0xFFFFE,	0xFFFFF	));
			//Add(	new Xml_invalid_range(0x10FFFE, 0x10FFFF));
		}

		private Xml_invalid_rangeList()
			: base()
		{
			init_instance();
		}


		public static string XmlValidString(string str_src)
		{
			if( string.IsNullOrEmpty( str_src))
				return "";
		
			string		str_ret	= str_src;

			foreach( Xml_invalid_range range in Instance)	// int ndx = 0; ndx < invalid_ranges.Length;ndx++)
			{
				str_ret	= str_ret.Replace( (char) range.Min, ' ');
				str_ret	= str_ret.Replace( (char) range.Max, ' ');
			}

			return str_ret;
		}
	}
